blob: a838c07293f2dcd479bb815e0ce1daea2609cc23 [file] [log] [blame]
khenaidoocfee5f42018-07-19 22:47:38 -04001#
2# Copyright 2016 the original author or authors.
3#
4# Licensed under the Apache License, Version 2.0 (the "License");
5# you may not use this file except in compliance with the License.
6# You may obtain a copy of the License at
7#
8# http://www.apache.org/licenses/LICENSE-2.0
9#
10# Unless required by applicable law or agreed to in writing, software
11# distributed under the License is distributed on an "AS IS" BASIS,
12# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
13# See the License for the specific language governing permissions and
14# limitations under the License.
15#
16
Matt Jeanneret2e3051a2019-05-11 15:01:46 -040017# set default shell
18SHELL = bash -e -o pipefail
Kent Hagerman074d0e02019-04-24 17:58:16 -040019
Zack Williams27f59a42019-05-10 09:12:07 -070020# Variables
Kent Hagermanf4a3aab2019-05-22 14:42:34 -040021VERSION ?= $(shell cat ./VERSION)
Zack Williams27f59a42019-05-10 09:12:07 -070022
Kent Hagermanf4a3aab2019-05-22 14:42:34 -040023DOCKER_LABEL_VCS_DIRTY = false
24ifneq ($(shell git ls-files --others --modified --exclude-standard 2>/dev/null | wc -l | sed -e 's/ //g'),0)
25 DOCKER_LABEL_VCS_DIRTY = true
26endif
Matt Jeanneret2e3051a2019-05-11 15:01:46 -040027## Docker related
David K. Bainbridgee14914d2019-05-24 13:43:05 -070028DOCKER_EXTRA_ARGS ?=
Kent Hagermanf4a3aab2019-05-22 14:42:34 -040029DOCKER_REGISTRY ?=
30DOCKER_REPOSITORY ?=
31DOCKER_TAG ?= ${VERSION}$(shell [[ ${DOCKER_LABEL_VCS_DIRTY} == "true" ]] && echo "-dirty" || true)
32RWCORE_IMAGENAME := ${DOCKER_REGISTRY}${DOCKER_REPOSITORY}voltha-rw-core
Andrea Campanella7a6cce22019-12-17 14:10:27 -080033TYPE ?= minimal
Matt Jeanneret2e3051a2019-05-11 15:01:46 -040034
35## Docker labels. Only set ref and commit date if committed
Kent Hagermanf4a3aab2019-05-22 14:42:34 -040036DOCKER_LABEL_VCS_URL ?= $(shell git remote get-url $(shell git remote))
37DOCKER_LABEL_VCS_REF = $(shell git rev-parse HEAD)
38DOCKER_LABEL_BUILD_DATE ?= $(shell date -u "+%Y-%m-%dT%H:%M:%SZ")
39DOCKER_LABEL_COMMIT_DATE = $(shell git show -s --format=%cd --date=iso-strict HEAD)
Matt Jeanneret2e3051a2019-05-11 15:01:46 -040040
Kent Hagermanf4a3aab2019-05-22 14:42:34 -040041DOCKER_BUILD_ARGS ?= \
David K. Bainbridgee14914d2019-05-24 13:43:05 -070042 ${DOCKER_EXTRA_ARGS} \
Kent Hagermanf4a3aab2019-05-22 14:42:34 -040043 --build-arg org_label_schema_version="${VERSION}" \
44 --build-arg org_label_schema_vcs_url="${DOCKER_LABEL_VCS_URL}" \
45 --build-arg org_label_schema_vcs_ref="${DOCKER_LABEL_VCS_REF}" \
46 --build-arg org_label_schema_build_date="${DOCKER_LABEL_BUILD_DATE}" \
47 --build-arg org_opencord_vcs_commit_date="${DOCKER_LABEL_COMMIT_DATE}" \
48 --build-arg org_opencord_vcs_dirty="${DOCKER_LABEL_VCS_DIRTY}"
49
50DOCKER_BUILD_ARGS_LOCAL ?= ${DOCKER_BUILD_ARGS} \
Kent Hagermanf4a3aab2019-05-22 14:42:34 -040051 --build-arg LOCAL_PROTOS=${LOCAL_PROTOS}
khenaidoocfee5f42018-07-19 22:47:38 -040052
Kent Hagerman812b2572020-01-28 11:57:51 -050053# tool containers
Kent Hagermandcd4dcc2020-02-25 17:56:17 -050054VOLTHA_TOOLS_VERSION ?= 2.0.0
Kent Hagerman812b2572020-01-28 11:57:51 -050055
Kent Hagerman1b820752020-02-14 14:45:51 -050056GO = docker run --rm --user $$(id -u):$$(id -g) -v ${CURDIR}:/app $(shell test -t 0 && echo "-it") -v gocache:/.cache -v gocache-${VOLTHA_TOOLS_VERSION}:/go/pkg voltha/voltha-ci-tools:${VOLTHA_TOOLS_VERSION}-golang go
Kent Hagerman812b2572020-01-28 11:57:51 -050057GO_JUNIT_REPORT = docker run --rm --user $$(id -u):$$(id -g) -v ${CURDIR}:/app -i voltha/voltha-ci-tools:${VOLTHA_TOOLS_VERSION}-go-junit-report go-junit-report
58GOCOVER_COBERTURA = docker run --rm --user $$(id -u):$$(id -g) -v ${CURDIR}:/app -i voltha/voltha-ci-tools:${VOLTHA_TOOLS_VERSION}-gocover-cobertura gocover-cobertura
Kent Hagerman1b820752020-02-14 14:45:51 -050059GOLANGCI_LINT = docker run --rm --user $$(id -u):$$(id -g) -v ${CURDIR}:/app $(shell test -t 0 && echo "-it") -v gocache:/.cache -v gocache-${VOLTHA_TOOLS_VERSION}:/go/pkg voltha/voltha-ci-tools:${VOLTHA_TOOLS_VERSION}-golangci-lint golangci-lint
60HADOLINT = docker run --rm --user $$(id -u):$$(id -g) -v ${CURDIR}:/app $(shell test -t 0 && echo "-it") voltha/voltha-ci-tools:${VOLTHA_TOOLS_VERSION}-hadolint hadolint
Kent Hagerman812b2572020-01-28 11:57:51 -050061
Kent Hagermand5e8bd52020-01-30 16:30:16 -050062.PHONY: rw_core local-protos
khenaidoocfee5f42018-07-19 22:47:38 -040063
64# This should to be the first and default target in this Makefile
65help:
66 @echo "Usage: make [<target>]"
67 @echo "where available targets are:"
68 @echo
David K. Bainbridge1678e192019-05-17 11:48:29 -070069 @echo "build : Build the docker images."
70 @echo " - If this is the first time you are building, choose 'make build' option."
71 @echo "rw_core : Build the rw_core docker image"
David K. Bainbridge1678e192019-05-17 11:48:29 -070072 @echo "clean : Remove files created by the build and tests"
Zack Williamsb9b1afb2019-12-09 15:28:52 -070073 @echo "distclean : Remove sca directory and clean"
David K. Bainbridge1678e192019-05-17 11:48:29 -070074 @echo "docker-push : Push the docker images to an external repository"
David Bainbridge5f3619c2019-07-10 22:51:09 +000075 @echo "lint-dockerfile : Perform static analysis on Dockerfiles"
girishk5259f8e2019-10-10 18:44:44 +000076 @echo "lint-mod : Verify the integrity of the 'mod' files"
David K. Bainbridge1678e192019-05-17 11:48:29 -070077 @echo "lint : Shorthand for lint-style & lint-sanity"
npujar03b018e2019-11-13 15:29:36 +053078 @echo "sca : Runs various SCA through golangci-lint tool"
David K. Bainbridge1678e192019-05-17 11:48:29 -070079 @echo "test : Generate reports for all go tests"
khenaidoocfee5f42018-07-19 22:47:38 -040080 @echo
81
David K. Bainbridge1678e192019-05-17 11:48:29 -070082## Local Development Helpers
83local-protos:
David K. Bainbridge1678e192019-05-17 11:48:29 -070084ifdef LOCAL_PROTOS
serkant.uluderya2ae470f2020-01-21 11:13:09 -080085 mkdir -p vendor/github.com/opencord/voltha-protos/v3/go
86 cp -r ${LOCAL_PROTOS}/go/* vendor/github.com/opencord/voltha-protos/v3/go
David K. Bainbridge1678e192019-05-17 11:48:29 -070087endif
88
Scott Bakercb7c88a2019-10-16 18:32:48 -070089## Local Development Helpers
90local-lib-go:
91ifdef LOCAL_LIB_GO
serkant.uluderya2ae470f2020-01-21 11:13:09 -080092 mkdir -p vendor/github.com/opencord/voltha-lib-go/v3/pkg
93 cp -r ${LOCAL_LIB_GO}/pkg/* vendor/github.com/opencord/voltha-lib-go/v3/pkg/
Scott Bakercb7c88a2019-10-16 18:32:48 -070094endif
95
Matt Jeanneret2e3051a2019-05-11 15:01:46 -040096## Docker targets
khenaidoocfee5f42018-07-19 22:47:38 -040097
Matt Jeanneret2e3051a2019-05-11 15:01:46 -040098build: docker-build
khenaidoocfee5f42018-07-19 22:47:38 -040099
Kent Hagermand5e8bd52020-01-30 16:30:16 -0500100docker-build: rw_core
sslobodra3ea7d42019-01-16 15:03:16 -0500101
Scott Bakercb7c88a2019-10-16 18:32:48 -0700102rw_core: local-protos local-lib-go
Matteo Scandolo450933a2020-04-30 07:47:08 -0700103 docker build $(DOCKER_BUILD_ARGS) -t ${RWCORE_IMAGENAME}:${DOCKER_TAG} -f docker/Dockerfile.rw_core .
104ifdef BUILD_PROFILED
105 docker build $(DOCKER_BUILD_ARGS) --build-arg EXTRA_GO_BUILD_TAGS="-tags profile" -t ${RWCORE_IMAGENAME}:${DOCKER_TAG}-profile -f docker/Dockerfile.rw_core .
106endif
David K. Bainbridge3768fde2020-07-29 21:15:35 -0700107ifdef BUILD_RACE
108 docker build $(DOCKER_BUILD_ARGS) --build-arg GOLANG_IMAGE=golang:1.13.8-buster --build-arg DEPLOY_IMAGE=debian:buster-slim --build-arg EXTRA_GO_BUILD_TAGS="--race" -t ${RWCORE_IMAGENAME}:${DOCKER_TAG}-rd -f docker/Dockerfile.rw_core .
109endif
Don Newton8eca4622020-02-10 16:44:48 -0500110
Matt Jeanneret2e3051a2019-05-11 15:01:46 -0400111docker-push:
Kent Hagermanf4a3aab2019-05-22 14:42:34 -0400112 docker push ${RWCORE_IMAGENAME}:${DOCKER_TAG}
Matteo Scandolo8ed186a2020-05-04 10:52:42 -0700113ifdef BUILD_PROFILED
114 docker push ${RWCORE_IMAGENAME}:${DOCKER_TAG}-profile
115endif
David K. Bainbridge3768fde2020-07-29 21:15:35 -0700116ifdef BUILD_RACE
117 docker push ${RWCORE_IMAGENAME}:${DOCKER_TAG}-rd
118endif
Andrea Campanella7a6cce22019-12-17 14:10:27 -0800119docker-kind-load:
120 @if [ "`kind get clusters | grep voltha-$(TYPE)`" = '' ]; then echo "no voltha-$(TYPE) cluster found" && exit 1; fi
121 kind load docker-image ${RWCORE_IMAGENAME}:${DOCKER_TAG} --name=voltha-$(TYPE) --nodes $(shell kubectl get nodes --template='{{range .items}}{{.metadata.name}},{{end}}' | rev | cut -c 2- | rev)
Andrea Campanella7a6cce22019-12-17 14:10:27 -0800122
Matt Jeanneret2e3051a2019-05-11 15:01:46 -0400123## lint and unit tests
khenaidood2b6df92018-12-13 16:37:20 -0500124
David Bainbridge5f3619c2019-07-10 22:51:09 +0000125lint-dockerfile:
Kent Hagermandcd4dcc2020-02-25 17:56:17 -0500126 @echo "Running Dockerfile lint check..."
Kent Hagerman812b2572020-01-28 11:57:51 -0500127 @${HADOLINT} $$(find . -name "Dockerfile.*")
David Bainbridge5f3619c2019-07-10 22:51:09 +0000128 @echo "Dockerfile lint check OK"
129
girishk5259f8e2019-10-10 18:44:44 +0000130lint-mod:
Kent Hagermanca4c51e2019-05-02 12:28:55 -0400131 @echo "Running dependency check..."
Kent Hagerman812b2572020-01-28 11:57:51 -0500132 @${GO} mod verify
Scott Bakere4c2a982019-11-21 16:32:03 -0800133 @echo "Dependency check OK. Running vendor check..."
134 @git status > /dev/null
Kent Hagermandcd4dcc2020-02-25 17:56:17 -0500135 @git diff-index --quiet HEAD -- go.mod go.sum vendor || (echo "ERROR: Staged or modified files must be committed before running this test" && git status -- go.mod go.sum vendor && exit 1)
136 @[[ `git ls-files --exclude-standard --others go.mod go.sum vendor` == "" ]] || (echo "ERROR: Untracked files must be cleaned up before running this test" && git status -- go.mod go.sum vendor && exit 1)
Kent Hagerman812b2572020-01-28 11:57:51 -0500137 ${GO} mod tidy
138 ${GO} mod vendor
Scott Bakere4c2a982019-11-21 16:32:03 -0800139 @git status > /dev/null
Kent Hagermandcd4dcc2020-02-25 17:56:17 -0500140 @git diff-index --quiet HEAD -- go.mod go.sum vendor || (echo "ERROR: Modified files detected after running go mod tidy / go mod vendor" && git status -- go.mod go.sum vendor && git checkout -- go.mod go.sum vendor && exit 1)
141 @[[ `git ls-files --exclude-standard --others go.mod go.sum vendor` == "" ]] || (echo "ERROR: Untracked files detected after running go mod tidy / go mod vendor" && git status -- go.mod go.sum vendor && git checkout -- go.mod go.sum vendor && exit 1)
Scott Bakere4c2a982019-11-21 16:32:03 -0800142 @echo "Vendor check OK."
143
Kent Hagerman0ab4cb22019-04-24 13:13:35 -0400144
Kent Hagermandcd4dcc2020-02-25 17:56:17 -0500145lint: lint-mod lint-dockerfile
Kent Hagerman074d0e02019-04-24 17:58:16 -0400146
Kent Hagerman812b2572020-01-28 11:57:51 -0500147sca:
148 @rm -rf ./sca-report
Scott Baker18ea5a42019-10-15 16:08:42 -0700149 @mkdir -p ./sca-report
Kent Hagerman812b2572020-01-28 11:57:51 -0500150 @echo "Running static code analysis..."
Kent Hagermand9cc2e92019-11-04 13:28:15 -0500151 @${GOLANGCI_LINT} run --deadline=6m --out-format junit-xml ./... | tee ./sca-report/sca-report.xml
Kent Hagerman1b820752020-02-14 14:45:51 -0500152 @echo ""
Kent Hagerman812b2572020-01-28 11:57:51 -0500153 @echo "Static code analysis OK"
Scott Baker18ea5a42019-10-15 16:08:42 -0700154
Kent Hagerman812b2572020-01-28 11:57:51 -0500155test: local-lib-go
Kent Hagermanca4c51e2019-05-02 12:28:55 -0400156 @mkdir -p ./tests/results
Kent Hagerman812b2572020-01-28 11:57:51 -0500157 @${GO} test -mod=vendor -v -coverprofile ./tests/results/go-test-coverage.out -covermode count ./... 2>&1 | tee ./tests/results/go-test-results.out ;\
Zack Williams7cf78002019-04-30 21:45:35 -0700158 RETURN=$$? ;\
Kent Hagerman812b2572020-01-28 11:57:51 -0500159 ${GO_JUNIT_REPORT} < ./tests/results/go-test-results.out > ./tests/results/go-test-results.xml ;\
160 ${GOCOVER_COBERTURA} < ./tests/results/go-test-coverage.out > ./tests/results/go-test-coverage.xml ;\
Zack Williams7cf78002019-04-30 21:45:35 -0700161 exit $$RETURN
Kent Hagerman074d0e02019-04-24 17:58:16 -0400162
Kent Hagerman812b2572020-01-28 11:57:51 -0500163clean: distclean
David K. Bainbridge1678e192019-05-17 11:48:29 -0700164
Kent Hagerman812b2572020-01-28 11:57:51 -0500165distclean:
166 rm -rf ./sca-report
David K. Bainbridge1678e192019-05-17 11:48:29 -0700167
Scott Bakercb7c88a2019-10-16 18:32:48 -0700168mod-update:
Kent Hagerman812b2572020-01-28 11:57:51 -0500169 ${GO} mod tidy
170 ${GO} mod vendor